%% Podstawy analizy sygnaw
% Cel: Analiza sygnau pod ktem jego charakteru. Jeeli jest to sygna typu szum, 
% to naley okreli jego kolor, jeeli okresowy, to naley obliczy jego okres. 
%
% Autor: Piotr Burnos
% Data: 22.02.2018

%%
clear all; close all; clc

%% Cztery, podstawowe etapy analizy sygnau (w uproszczeniu):
% 
% # Wizualna inspekcja sygnau
% # Wybr metody analizy sygnau
% # Uycie funkcji lub implementacja algorytmu
% # Walidacja wynikw i wnioski
% 

%% 1) Wizualna ocena sygnau 
% Wczytujemy dane do Matlaba, rysujemy sygna w funkcji czasu 

load Matlab2018_dane_pomiarowe_cz6

dni = ...;
temp = ...;


dt = ...;           % okres prbkowania w sekundach (moe sie przyda pniej)

% przeliczenie na stopnie Celsiusa
temp = ...;
    
figure; plot(dni, temp); grid on; title('Temperatura'); xlabel('Czas [dni]'); ylabel('Temperatura [C]')


%% 2) Wybr metody analizy sygnau
% Na podstawie oceny wizualnej sygnau wybieramy korelacyjn metod jego
% analizy. Przechodzimy do punktu 3. 


%% 3) Wybr algorytmu
% W Matlabie funkcj ocen funkcji kowariancji oblicza funkcja xcov - jej
% poprawne uzycie jest opisane w 'Pomocy' Matlaba

maxTal = ...;     % maksymalne przesunicie rwne 1/2 dugoci sygnau

[Cxx, Tal] = ...;

Tal = ...;        % wektor przesuni przeskalowany do dni 


%% 4) Walidacja wynikw i wnioski
% Obliczon funkcj autokowariancji sygnau naley narysowa w funkcji
% przesunicia Tal. Czy otrzymany wynik pokrywa si z oczekiwaniami? Czy
% jest poprawny? Jeeli tak, to jakie wnioski mozna wycign z ksztatu
% funkcji kowariancji?

% Rysunek:



%% Dodatkowo:
% Uywajc funkcji findpeaks nanie na rysunku markery wskazujce na maksima funkcji kowariancji. 
% Obliczy numerycznie okres skadowych zmiennych w rejestracji temperatury. 

